from search_trees import BinarySearchTree
from random import randint as random

MAX= 1000
MIN = 0
LENGTH = 100

def test_insert():
    nums = [random(MIN, MAX) for _ in range(0, LENGTH)]
    bst = BinarySearchTree()
    for num in nums:
        bst.insert(num)
    assert list(iter(bst)) == sorted(nums)
    
def test_remove():
    nums = {random(MIN, MAX) for _ in range(0, LENGTH)}
    fil = {random(MIN, MAX) for _ in range(0, LENGTH // 4)}
    bst = BinarySearchTree()
    for num in nums:
        bst.insert(num)
    for num in fil:
        bst.remove(num)
        
    assert list(iter(bst)) == sorted(filter(lambda x: x not in fil, nums))